Bulk Ranks


This endpoint will provide you with rank scores of the domains, subdomains, and pages specified in the targets array. The score is based on the number of referring domains pointing to the specified domains, subdomains, or pages. The rank values represent real-time data for the date of the request and range from 0 (no backlinks detected) to 1,000 (highest rank). A similar scoring system is used in Google’s Page Rank algorithm. You can learn more about rank scores in this help center article

checked POST
Pricing

Your account will be charged for each request.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, each Live API call can contain only one task. The maximum number of calls that can be sent simultaneously is limited to 30.

Below you will find a detailed description of the fields you can use for setting a task.

Description of the fields for setting a task:

Field nameTypeDescription
targetsarray

domains, subdomains or webpages to get rank for
required field
you can set up to 1000 domains, subdomains or webpages
the domain or subdomain should be specified without https:// and www.
the page should be specified with absolute URL (including http:// or https://)
example:
"targets": [
"forbes.com",
"cnn.com",
"bbc.com",
"yelp.com",
"https://www.apple.com/iphone/",
"https://ahrefs.com/blog/",
"ibm.com",
"https://variety.com/",
"https://stackoverflow.com/",
"www.trustpilot.com"
]

rank_scalestring

defines the scale used for calculating and displaying the rank, domain_from_rank, and page_from_rank values
optional field

you can use this parameter to choose whether rank values are presented on a 0–100 or 0–1000 scale

possible values:
one_hundred — rank values are displayed on a 0–100 scale
one_thousand — rank values are displayed on a 0–1000 scale

default value: one_thousand

learn more about how this parameter works and how ranking metrics are calculated in this Help Center article

tagstring

user-defined task identifier
optional field
the character limit is 255
you can use this parameter to identify the task and match it with the result
you will find the specified tag value in the data object of the response

As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of the response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results

        items_countinteger

the number of results returned in the items array

        itemsarray

contains relevant backlinks and referring domains data

            targetstring

domain, subdomain or webpage from a POST array

            rankinteger

rank of the target
values represent real-time data for the date of the request
rank is calculated based on the method for node ranking in a linked database - a principle used in the original Google PageRank algorithm
learn more about the metric and how it is calculated in this help center article

‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/backlinks/bulk_ranks/live" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
    {
      "targets": [
          "forbes.com",
          "cnn.com",
          "bbc.com",
          "yelp.com",
          "https://www.apple.com/iphone/",
          "https://ahrefs.com/blog/",
          "ibm.com",
          "https://variety.com/",
          "https://stackoverflow.com/",
          "www.trustpilot.com"
      ]
    }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
$client = new RestClient($api_url, null, 'login', 'password');

$post_array = array();
// simple way to set a task
$post_array[] = array(
	"targets" => [
        "forbes.com",
		"cnn.com",
		"bbc.com",
		"yelp.com",
		"https://www.apple.com/iphone/",
		"https://ahrefs.com/blog/",
		"ibm.com",
		"https://variety.com/",
		"https://stackoverflow.com/",
		"www.trustpilot.com"
	]
);
try {
	// POST /v3/backlinks/bulk_ranks/live
	$result = $client->post('/v3/backlinks/bulk_ranks/live', $post_array);
	print_r($result);
	// do something with post result
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
}
$client = null;
?>
const post_array = [];
post_array.push({
  "targets": [
    "forbes.com",
    "cnn.com",
    "bbc.com",
    "yelp.com",
    "https://www.apple.com/iphone/",
    "https://ahrefs.com/blog/",
    "ibm.com",
    "https://variety.com/",
    "https://stackoverflow.com/",
    "www.trustpilot.com"
  ]
});
const axios = require('axios');
axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/backlinks/bulk_ranks/live',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
    targets=[
        "forbes.com",
		"cnn.com",
		"bbc.com",
		"yelp.com",
		"https://www.apple.com/iphone/",
		"https://ahrefs.com/blog/",
		"ibm.com",
		"https://variety.com/",
		"https://stackoverflow.com/",
		"www.trustpilot.com"
    ]
)
# POST /v3/backlinks/bulk_ranks/live
response = client.post("/v3/backlinks/bulk_ranks/live", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task backlinks_bulk_backlinks_live()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }                
            };
            var postData = new List<object>();
            postData.Add(new
            {
                targets = new[]
                {
                    "forbes.com",
                    "cnn.com",
                    "bbc.com",
                    "yelp.com",
                    "https://www.apple.com/iphone/",
                    "https://ahrefs.com/blog/",
                    "ibm.com",
                    "https://variety.com/",
                    "https://stackoverflow.com/",
                    "www.trustpilot.com"
                }
            });
            // POST /v3/backlinks/bulk_backlinks/live
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/backlinks/bulk_backlinks/live", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
  "version": "0.1.20210917",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "0.5195 sec.",
  "cost": 0.0203,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "10131644-1535-0347-0000-750206cf57d8",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "0.4631 sec.",
      "cost": 0.0203,
      "result_count": 1,
      "path": [
        "v3",
        "backlinks",
        "bulk_ranks",
        "live"
      ],
      "data": {
        "api": "backlinks",
        "function": "bulk_ranks",
        "targets": [
          "forbes.com",
          "cnn.com",
          "bbc.com",
          "yelp.com",
          "https://www.apple.com/iphone/",
          "https://ahrefs.com/blog/",
          "ibm.com",
          "https://variety.com/",
          "https://stackoverflow.com/",
          "www.trustpilot.com"
        ]
      },
      "result": [
        {
          "items_count": 10,
          "items": [
            {
              "target": "https://www.apple.com/iphone/",
              "rank": 848
            },
            {
              "target": "https://ahrefs.com/blog/",
              "rank": 395
            },
            {
              "target": "https://variety.com/",
              "rank": 697
            },
            {
              "target": "https://stackoverflow.com/",
              "rank": 740
            },
            {
              "target": "www.trustpilot.com",
              "rank": 702
            },
            {
              "target": "forbes.com",
              "rank": 650
            },
            {
              "target": "cnn.com",
              "rank": 664
            },
            {
              "target": "bbc.com",
              "rank": 654
            },
            {
              "target": "yelp.com",
              "rank": 694
            },
            {
              "target": "ibm.com",
              "rank": 656
            }
          ]
        }
      ]
    }
  ]
}